version: '3'

services:
  mongo-setup:
    network_mode: host
    container_name: mongo-setup
    image: mongo:5.0
    restart: on-failure
    healthcheck:
      test:
        ["CMD", "mongo","--host","localhost", "-u", "admin", "-p", "admin123", "--port","27017","--eval", 'rs.initiate( { _id : "rs0",members: [{ _id: 0, host: "localhost:27017" },{ _id: 1, host: "localhost:27018" },{ _id: 2, host: "localhost:27019" }   ]})' ]
      interval: 10s
    depends_on:
      - mongo1
      - mongo2
      - mongo3
    volumes:
      - ./keyfile:/keyfile
    command: [ "--port", "27016", "--keyFile", "/keyfile", "--replSet", "rs0", "--bind_ip_all" ]

  mongo1:
    network_mode: host
    hostname: mongo1
    container_name: localmongo1
    image: mongo:5.0
    environment:
      - MONGO_INITDB_ROOT_USERNAME=admin
      - MONGO_INITDB_ROOT_PASSWORD=admin123
    restart: always
    volumes:
      - ./keyfile:/keyfile
      - ./mongo/data1/db:/data/db
      - ./mongo/data1/configdb:/data/configdb
    command: [ "--port", "27017", "--keyFile", "/keyfile", "--replSet", "rs0", "--bind_ip_all" ]
  mongo2:
    network_mode: host
    hostname: mongo2
    container_name: localmongo2
    image: mongo:5.0
    restart: always
    volumes:
      - ./keyfile:/keyfile
      - ./mongo/data2/db:/data/db
      - ./mongo/data2/configdb:/data/configdb
    command: [ "--port", "27018", "--keyFile", "/keyfile", "--replSet", "rs0", "--bind_ip_all" ]

  mongo3:
    network_mode: host
    hostname: mongo3
    container_name: localmongo3
    image: mongo:5.0
    restart: always
    volumes:
      - ./keyfile:/keyfile
      - ./mongo/data3/db:/data/db
      - ./mongo/data3/configdb:/data/configdb
    command: [ "--port", "27019","--keyFile", "/keyfile", "--replSet", "rs0", "--bind_ip_all" ]
